# `go get`命令

`go get`民引领基本上是在 Go 程序构建的过程中使用的最多的一个命令了。它的主要功能就是下载依赖包到本地缓存并将其添加到项目的`go.mod`依赖描述中。

`go get`命令的使用格式为`go get [-t] [-u] [-v] [编译标记] [依赖包]`。

## 控制项目的依赖

下载一个依赖包的最新版本是非常简单的，可以直接使用以下命令。

```bash
go get archgrid.xyz/pkg
```

如果需要下载一个指定的版本，只需要使用`@`符号即可。

```bash
go get archgrid.xyz/pkg@0.1.0
```

移除一个依赖包就比较有技巧了，可以使用`@none`版本标记。

```bash
go get archgrid.xyz/pkg@none
```

## 升级项目中的依赖

升级项目中的依赖包版本可以使用`go get -u`，如果不指定具体要升级的依赖包名称和版本，那么将会升级项目中所使用到的全部依赖包的版本。

## 旧版本 Go 中的`go get`

`go get`命令在旧版本 Go 或者在没有使用 Go Module 的项目中，其实际下载依赖包的动作会很不一样。

首先，`go get`命令不会将下载的依赖包添加到`go.mod`文件中，因为在不使用 Go Module 时，项目中也不会有`go.mod`文件。

其次，`go get`命令会对下载的依赖包进行编译和安装，这一点就有点儿像`go install`命令了。
