# `go run`命令

`go run`命令的功能非常直接，就是编译并运行指定的包。`go run`的命令格式为`go run [编译参数] 要执行的包 [程序运行参数]`。

其实大部分情况下都是使用最简单的`go run main.go`。如果程序的运行需要参数，可以直接在指定要运行的包或者文件名后面列出即可。

```admonish tip
通过`go run`启动执行的程序，从其中通过`os.Args`获取到的程序运行参数并不会有什么特殊的变化，`os.Args[0]`依旧是程序的名字，`os.Args[1]`是第一项参数。
```

能够被运行的文件其实是有一定要求的，首先这个文件必须要隶属于`main`包，也就是在文件的开头使用`package main`声明。其次其中必须定义一个`func main()`的函数。

如果一个 Module 中所有隶属于`main`包的文件中，只存在一个`func main()`函数，那么就可以通过`go run module名称`的方式来运行。如果有多个`func main()`函数，那么就需要进行具体的指定了。
