# Go 语言简介

以下是来自 Go 官方网站对于 Go 语言的介绍：“Go 是一种考虑到系统编程而设计的通用语言。它是强类型的和垃圾收集的，并且明确支持并发编程。程序是由包构建的，包的属性允许有效地管理依赖关系。语法紧凑且易于解析，允许通过集成开发环境等自动工具进行轻松分析。”

Go 的诞生，其主要目的是为了应对逐渐普及的并行计算技术。尤其是在硬件性能普遍支持了并行计算，而编程软件在并行计算方面却一直采用传统的并行处理技术的情况下。在这种技术背景下，Go 语言应时而生，成为了一门专为这个时代硬件诞生的语言。但是这并不代表 Go 会受到时代的局限。

谷歌公司的三位大神 Robert Griesemer（Java HotSpot 虚拟机、Javascript V8 引擎作者之一）、Rob Pike（贝尔实验室 Unix 团队成员）、Ken Thompson（贝尔实验室 Unix 团队成员，C 语言、Unix 和 Plan 9 创始人之一）为 Go 语言设定了以下目标。

1. Go 将成为互联网时代的 C 语言，并且跟 C 语言一样足够简单。
1. 消除缓慢与笨重、改进低效与扩展性，为开发大型系统设计，为了解决工程上的问题存在。
1. 类似于 C 语言，易于学习，拥有现代化的技术。

基于这三个目标，三位行动派大神迅速展开了对于 Go 的设计工作。从 2007 年开始设计，到 2008 年转为谷歌内部的正式项目，Go 语言最终在 2009 年 11 月 10 日正式开源，而这一天也被确定为 Go 语言的生日。真正能够投入生产使用的 Go version 1 是在 2012 年 3 月发布的。

但是 Go 1.11 之前的版本并不好用，这并不是因为 Go 语言本身语法和功能设计的问题，而主要是 Go 对于项目依赖的管理问题。与其他的语言不通，Go 直接将 Github 当做了它的依赖存储库，项目的依赖都会从 Github 上直接获取。但是在 Go 1.11 版本之前，Go 在获取依赖的时候，并不能确定依赖库的版本，而是会直接下载依赖的最新版本。这也就导致了，如果在本地有两个依赖于同一个库的不通版本的项目，使用老版本依赖库的项目，必然要在依赖库更新以后不断地做大量的适配重构工作。

Go 1.11 版本推出了 Go Module 的概念，基本上解决了不同项目之间依赖同一依赖库的不同版本问题，也让 Go 的项目管理变得更加现代化了。Go 1.18 版本加入的泛型，则让 Go 更加的灵活了起来，尤其是不必再遍地使用`interface{}`来指代任意类型的对象。

这本小书将直接从 Go 1.20 版本开始介绍，所以对于 Go 之前版本中存在的问题和已经不再必要的功能都不再描述了。本书内容将主要以 Go 官网上的语言规范和标准库文档为准，以求尽可能做到对于 Go 的各项功能描述准确。
