# 依赖版本的发布

发布一个模块的指定版本并不是一个困难的事情，只需要了解了 Go 命令是如何去解析模块的版本的，就可以非常轻松自如的发布自己项目模块的不同版本。

Go 在设计之初就把 Github 作为了其所有依赖的存储库，所以对于模块路径和版本的解析也都是几乎完全针对 Git 设计的。对于模块版本的解析，一个最简单也是使用最普遍的情况就是如果一个模块被放置在存储库的根目录中，那么就可以通过 Git 版本库的 tag 功能来发布模块的版本。此时 tag 的名称只需要是前面所叙述的语义化版本即可。

如果模块是在存储库中的子目录中定义的，那么存储库中的 tag 名称就必须增加子目录名称作为版本号前缀。例如 Go 工具库`golang.org/x/tools/gopls`就是在其存储库`golang.org/x/tools`的子目录`gopls`中定义的，那么`gopls`在发布的时候，其 tag 名称就必须为`gopls/v0.4.0`的形式。

如果项目没有发布在 Github 上，那么只要项目使用的是基于 Git 的存储库，那么都可以使用这个方法来发布项目的版本。
